package com.zerohighdef.geoffrey.Models;

import com.google.common.collect.Iterables;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;

import java.util.LinkedList;

public class GeoffreyTown extends GeoffreyLocation {
    private LinkedList<GeoffreyPlayer> residents;

    public GeoffreyTown(JsonObject locationJSON) {
        super(locationJSON);
        this.residents = new LinkedList<>();
        for (JsonElement json : locationJSON.get("residents").getAsJsonArray()) {
            this.residents.add(new GeoffreyPlayer(json.getAsJsonObject()));
        }
    }

    public GeoffreyTown(int xCoord, int zCoord, String locationName, GeoffreyPlayer owner, String dimension, LinkedList <GeoffreyPlayer> residents) {
        super(xCoord, zCoord, locationName, owner, dimension);
        this.residents = residents;
    }

    @Override
    public String getInfoString() {
        StringBuilder locationString = new StringBuilder();
        locationString.append(super.getInfoString());
        locationString.append("\nResidents:");

        for (GeoffreyPlayer resident: Iterables.limit(residents, 5)) {
            locationString.append("\n");
            locationString.append(resident.getUsername());
        }

        return locationString.toString();
    }
}
